/* Hobbit's efforts at a unified s/key. */

/*   change password or add user to S/KEY authentication system.
 *   S/KEY is a tradmark of Bellcore  */

#include "generic.h"
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <time.h>
#include <sys/types.h>
#include <ctype.h>

/* chasin turds: fledgling SV shadow support that apparently never got
   off the ground.  Inserted here in case anyone wants to work on it. */
#ifdef __svr4__
#include <sys/systeminfo.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
/* #include <shadow.h>
/* #include "sysv_shadow.h"
*/
#endif /* __svr4__ */

/* Y'know, the more I look at this stuff, the more I get REALLY FUCKING
   TIRED of dealing with the turds left behind by someone who thinks that
   taking someone else's work, running it through "cb" and changing a few
   lousy strings, is genuinely productive.  That is why the first crack
   at this still contains most of the illiteracies and cosmetic booboos
   and inefficient code and outright misnomers, just so I can isolate the
   work that went into merging the two [or maybe three] trees -- and LATER,
   I can address that other stuff once the base stuff is finally working.

   Thanks so much, Scott, but no offense, really.  It's just making my life
   miserable right now, but I'll feel better later, and we'll probably
   have a good loud yuk over it all at some future conference.  _H*/

#include "skey.h"

extern int optind;
extern char *optarg;

char * readpass();

int skeylookup __ARGS((struct skey *mp,char *name));

#define NAMELEN 2
int
main(argc,argv)
int argc;
char *argv[];
{
	struct skey skey;
	int rval,n,nn,i,defaultsetup;
	char seed[18],tmp[80],key[8];
	struct passwd *ppuser,*pp;
	char defaultseed[17], passwd[256],passwd2[256] ;


	time_t now;
	struct tm *tm;
	char tbuf[27],buf[60];
	char lastc, me[80];
	int l;

	time(&now);
	tm = localtime(&now);
	strftime(tbuf, sizeof(tbuf), "%M%j", tm);
#ifdef DEBUG
printf ("Time part: %s - ", tbuf);
#endif
/* Limiting gethostname's len to something short cuts it down to NOTHING on
   some machines, so this double-bounce idiocy is needed */
	gethostname(passwd2,255);
	memset (defaultseed, 0, 16);
	strncpy (defaultseed, passwd2, NAMELEN);
#ifdef DEBUG
printf ("Hostname part: %s\n", defaultseed);
#endif
	strcpy(&defaultseed[NAMELEN],tbuf);
	pp = ppuser = getpwuid(getuid());
/* chasin */
  if (pp == NULL) {
     fprintf(stderr, "Who are you?\n");
     exit(1);
  }
	strcpy(me,pp->pw_name);
	defaultsetup = 1;
	if( argc > 1){
		if(strcmp("-s", argv[1]) == 0)
			defaultsetup = 0;
		else
			pp = getpwnam(argv[1]);
		if(argc > 2)
			pp = getpwnam(argv[2]);

	}
	if(pp == NULL){
		printf("User unknown\n");
		exit (1);
	}
#ifndef TEST
	if(strcmp( pp->pw_name,me) != 0){
		if(getuid() != 0){
			/* Only root can change other's passwds */
			printf("Permission denied.\n");
			exit(1);
		}
	}
#endif /* TEST */
/* Chasin's version insisted on checking the user's regular password here.
   Instead, we demand the next old s/key for proof of identity, which is much
   more portable than trying to deal with numerous shadow mechanisms.  _H*/

/* Clear the struct first; if it's initialized to garbage [notably under GCC]
   bad things happen.  Or as meister sez, "initialize, dammit." _H*/
	memset (&skey, 0, sizeof (struct skey));

	rval = skeylookup(&skey, pp->pw_name);
	switch(rval){
	case -1:
		perror("error in opening database");
		exit (1);
	case 0:
/* Begin H* fix: check his old s/key.  If he's down to 0 already, "see your
   system administrator".  Unless we *are* the administrator.  Bwahaha. */
		if (getuid() == 0)
			goto just_effing_do_it;
		rval = skeychallenge(&skey,pp->pw_name, tmp);
		/* database is open ... */
		printf ("[%s]\n(to verify you): ", tmp);
		fflush (stdout);
		readpass (tmp, sizeof(tmp));
		rval = skeyverify(&skey, tmp);
		/* database updated and closed, for now */
		if (rval != 0 ) {
			fprintf (stderr, "Invalid response\n");
			exit (1);
		}
/* Note that skeykeys got updated and closed, so we have to reopen it */
just_effing_do_it:
		if (skeylookup(&skey, pp->pw_name) != 0) {
			fprintf (stderr, "Database open failed!!\n");
			exit (1);
		}
		printf("Updating %s:\n",pp->pw_name);
/*		printf("Old key: %s\n",skey.seed);	/* xxx: "seed" */
/* xxx: why not just getpid() or time() or something, and crunch it?! */
/* lets be nice if they have a skey.seed that ends in 0-8 just add one*/
		l = strlen(skey.seed);
		if( l > 0){
			lastc = skey.seed[l-1];
			if( isdigit(lastc) && lastc != '9' ){
				strcpy(defaultseed, skey.seed);
				defaultseed[l-1] = lastc + 1;
			}
			if( isdigit(lastc) && lastc == '9' && l < 16){
				strcpy(defaultseed, skey.seed);
				defaultseed[l-1] = '0';
				defaultseed[l] = '0';
				defaultseed[l+1] = '\0';
			}
		}
		break;
	case 1:
		printf("Adding %s:\n",pp->pw_name);
		break;
	}  /* switch */
    n = 99;
    if( ! defaultsetup){
/* Okay, now I'm gonna start doing the Literacy Thing.  _H*/
	printf("Reminder: you need the output from the \"skey\" program.\n");
	for(i=0;;i++){
		if(i >= 2) exit(1);
		printf("Enter sequence count from 1 to 10000: ");
		fflush (stdout);
		fgets(tmp,sizeof(tmp),stdin);
		printf ("\n");
		n = atoi(tmp);
		if(n > 0 && n < 10000)
			break;	/* Valid range */
		printf("Count must be > 0 and < 10000\n");
	}
    }
    if( !defaultsetup){			/* xxx: this is extraneous */
	printf("Enter new seed [default %s]: ", defaultseed);
	fflush(stdout);
	fgets(seed,sizeof(seed),stdin);
	rip(seed);
	if(strlen(seed) > 16){
		printf("Seed truncated to 16 chars\n");
		seed[16] = '\0';
	}
	if( seed[0] == '\0') strcpy(seed,defaultseed);
	for(i=0;;i++){
		if(i >= 2) exit(1);
#ifdef MD5
	printf("Don't forget, use an S/Key calculator with MD5.\n");
#endif
/* xxx: "access password"?!?! */
#ifdef MD5
		printf("s/key (MD5) %d %s\ns/key response: ",n,seed);
#else
		printf("s/key %d %s\ns/key response: ",n,seed);
#endif
		fgets(tmp,sizeof(tmp),stdin);
		rip(tmp);
		backspace(tmp);
/* xxx: do something more intelligent here */
		if(tmp[0] == '?'){
			printf("Enter 6 English words from secure S/Key calculation.\n");
			continue;
		}
		if(tmp[0] == '\0'){
			exit(1);
		}
/* xxx: these return different things for failure?! */
		if((etob(key,tmp) == 1) || (atob8(key,tmp) == 0))
			break;	/* Valid format */
		printf("Invalid format, try again with either of\n");
		printf("  6 English words\n  16 hex digits\n");
	}
    } else {  /* defaultsetup */

	/* Get user's secret password */
	fprintf(stderr,"Reminder - Only use this method if you are directly connected.\n");
	fprintf(stderr,"If you are remote via telnet or dial-in, exit with no\n");
	fprintf(stderr,"password and use skeyinit -s.\n");
#ifdef MD5
	fprintf(stderr,"Don't forget, I'm using MD5 to encrypt this.\n");
#endif
	/* NOTE from Dan McD.:  Ran Atkinson suggested that maybe an
	   environment check for the DISPLAY variable would be in order.  
	   If DISPLAY was not local, bail out of the program and display
	   a suitable warning message.  This would be a nice addition. */
/* xxx: how 'bout comparing utmp-hostname vs. gethostname()?  _H*/

	for(i=0;;i++){
		if(i >= 2) exit(1);
		fprintf(stderr,"Enter secret password: ");
		readpass(passwd,sizeof(passwd));
		if(passwd[0] == '\0'){
			exit(1);
		}
		fprintf(stderr,"Again secret password: ");
		readpass(passwd2,sizeof(passwd));
		if(passwd2[0] == '\0'){
			exit(1);
		}
/* xxx: dictionary check a la npasswd? */
		if(strlen(passwd) < 4 && strlen(passwd2) < 4) {
			fprintf(stderr, "Sorry your password must be longer\n\r");
			exit(1);
		}
		if(strcmp(passwd,passwd2) == 0) break;
		fprintf(stderr, "Sorry no match\n");

	} /* for i */
	strcpy(seed,defaultseed);

	/* Crunch seed and password into starting key */
	if(keycrunch(key,seed,passwd) != 0){
		fprintf(stderr,"%s: key crunch failed\n",argv[0]);
		return 1;
	}
	nn = n;
	while(nn-- != 0)
		f(key);
    } /* defaultsetup */		/* xxx: cosmetic horror */

	time(&now);
	tm = localtime(&now);
	strftime(tbuf, sizeof(tbuf), " %b %d,%Y %T", tm);
        if (skey.val == NULL)
                  skey.val = (char *)malloc(16+1);
/* XXX: the above malloc inconsistently returns *4*, or a real pointer, on
   mit-solaris+gcc, but it might be a gcc bug.  You are warned.
   Why we're bothering to malloc a lousy 17 bytes, I can't imagine. */
#ifdef DEBUG
printf ("Malloc @ %x\n", skey.val);
#endif

	btoa8(skey.val,key);
/* xxx: shouldn't this be an atomic function, like skeyupdate() or sumpin? */
	fprintf(skey.keyfile,"%s %04d %-16s %s %-21s\n",pp->pw_name,n,
		seed,skey.val, tbuf);
	fclose(skey.keyfile);
	printf("\nID %s s/key is %d %s\n",pp->pw_name,n,seed);
	printf("%s\n",btoe(buf,key));
#ifdef HEXIN
	printf("%s\n",put8(buf,key));
#endif
	exit (0);
}

/* chasin */
#ifdef __svr4__
int gethostname (name, len)
char *name;
int len;
{ 
   int  namelen = 128;
 
   if (sysinfo (SI_HOSTNAME, name, len) <0)  {
        perror("hostname");
        return -1;
   }
   return 0;
}
#endif
